#Joyce Zhu 7/20/2014 jqzhu@seas.harvard.edu
#Python script to read and cherry pick relevant data out of an ABAQUS-generated
#.dat file and add it to a central output file.

#These first 2 variables are automatically modified by the preparation script
DAT_FILENAME = 'MG_20.dat'
STEP_NUMBER = 60
#You'll need to change this yourself before running the preparation script
FINAL_OUTPUT_FILE = '/n/home10/jqzhu/finalOutput.txt'

#First, open both .dat and output files for processing
dat_file = open(DAT_FILENAME)
output_file = open(FINAL_OUTPUT_FILE, 'a+')
#w]We'll store everything we want to write to the file in a list
relevant_lines = []
#If the file is empty, we can write straight to it as we're not appending anything.
#Otherwise, we'll add the step name to the temporary list to write to the file later
if STEP_NUMBER is 1:
   output_file.write("Step %i\n" % (STEP_NUMBER))
relevant_lines.append("\tStep %i" % (STEP_NUMBER))
while True: #go through all lines of .dat file until we find the data
  line = dat_file.readline()
  current_line += 1
  #change (RAD/TIME) to whatever string indicates the line before you want to start reading data
  if "(RAD/TIME)" in line: #find the line with (RAD/TIME), as this indicates where we need to break and start reading data.
     dat_file.readline(); dat_file.readline() #skip 2 blank lines before data starts
     for i in range(30): #30 is just the number of data points here; change as needed
        data = dat_file.readline().split()
        if STEP_NUMBER is 1: #again, write directly to empty file and append to temp list for existing text
           output_file.write(data[2] + '\n') #data[2] is the field we wanted for our simulation; change as needed for your work
        else:
           relevant_lines.append(data[2])
     break
  if not line: #handle end of file (should not be triggered!)
     print "Data you wanted not found!"
     break
if STEP_NUMBER is 1: #in this case we've already written everything, so we're done
    exit()
#otherwise, we need to rewrite the output file
all_lines = output_file.readlines()
for i in range(len(relevant_lines)): #copy all the data over separated by tabs
   all_lines[i] = all_lines[i][:-1] + "\t" + relevant_lines[i] + "\n" #[:-1] strips the newline
output_file.close()
open(FINAL_OUTPUT_FILE, 'w').write(''.join(all_lines)) #rewrite the output file with the new data appended
dat_file.close()
