#!/bin/bash

#Simple mass ABAQUS job submission after running prepareAbaqus.sh.
#Joyce Zhu 6/20/14 jqzhu@seas.harvard.edu
#7/10/14: ported code from SGE to SLURM job submission engine
##################################
#Variables. Job limit is optional. If you don't want a job limit, just comment out the "sleep 30" line.
#Make sure variables shared across files match up!
JOB_LIMIT=10
SHELL_FILE=runAbaqus.sh
START_JOB=1
RESOLUTION=0.05
NUMBER_STEPS=3
SCRATCH_DIR=/n/home10/jqzhu/slurm
#GROUP_DIR=/group/bertoldi/joyce
GROUP_DIR=/n/home10/jqzhu/slurm
JOBS_PER_STEP=$(python -c "print int(1.0 / $RESOLUTION)")
let "TOTAL_JOBS=$NUMBER_STEPS*$JOBS_PER_STEP"
END_JOB=$TOTAL_JOBS
##################################
for i in `seq $START_JOB $END_JOB`;
do
  currentDirectory="$SCRATCH_DIR"/job_"$i"-*
  cd $currentDirectory
  #control how many jobs in the queue at a given time. Optional. $USER is a bash environment variable
  while [[ $(squeue -u $USER | grep -c $USER) -ge $JOB_LIMIT ]];
  do
     sleep 30
  done
  sbatch $SHELL_FILE
  #return back to current folder when done
  cd $SCRATCH_DIR
  sleep 5
done
echo
echo "All jobs submitted!"
